#include <stdio.h>
#include <string.h>
#include "linux/config.h"

#define include_ipsec
extern int vconfig_main( int argc, char *argv[]);
extern int brctl_main(int argc, char *argv[]);
extern int vpctrl_main(int argc, char *argv[]);
extern int mac_config_main(int argc, char *argv[]);
struct app_record {
		char *name;
		int (*main)(int, char **);
};


/* Most frequently run applications first. */
struct app_record app_records[] = {
	{ "vpctrl", vpctrl_main },
	{ "brctl", brctl_main },
	{ "vconfig", vconfig_main }
};

#define MAX_APP_RECORDS (sizeof(app_records)/sizeof(struct app_record))

char *get_app_name(char *path)
{
	char *p;

	p = strrchr(path, '/');
	if (!p)
	{
		return path;
	}
	p++;
	return p;
}

int main(int argc, char *argv[])
{
	int i;
	char *app_name = get_app_name(argv[0]);

	for (i = 0; i < MAX_APP_RECORDS; i++)
	{
//		printf("%s,%s\n",app_name,app_records[i].name);sdsd
		if (strcmp(app_name, app_records[i].name) == 0)
		{
			return app_records[i].main(argc, argv);
		}
	}
	printf("Application %s not found\n", app_name);
	return -1;
}
