/*
 * Copyright 2001-2003, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: linux_igd.c,v 1.6 2003/11/08 09:35:52 honor Exp $
 */

#include <sys/ioctl.h>
#include <net/if.h>
//#include <linux/sockios.h>
#include <linux/socket.h>
#include <signal.h>
#include <signal.h>

#define __KERNEL__
#include <asm/types.h>
#include <linux/sockios.h>
#include <linux/ethtool.h>

#include "upnp_dbg.h"
#include "upnp_osl.h"
#include "upnp.h"
#include "../igd/igd.h"
//#include "shutils.h"
#include "bcmnvram.h"


#define _PATH_PROCNET_DEV           "/proc/net/dev"
#define UPNP_TABLE_FILE "/flash/upnptable.conf"
#define UPNP_SETTING_FILE "/flash/upnpsetting.conf"
#define UPNP_DEBUG 0
#define MAX_T 16 
extern char * safe_snprintf(char *str, int *len, const char *fmt, ...);
typedef struct _testS{
	char var[25];		
	char val[50];		
} testS;
testS testConfig[MAX_T]={
{"wan_ifname"," "},
{"?upnp_ex","999-999>192.168.1.99:999-999,udp,off,example"}
};


typedef struct _upnp_tableS{
        char var[15];
        char val[127];
	struct _upnp_tableS *next;
} upnptableS;
upnptableS *upnp_table=NULL;
//upnptable=NULL;

#if 1 //jj
void do_command(char *cmd)
{
        pid_t pid;

        if (!(pid = vfork())) {
                execlp("sh", "sh", "-c", cmd, NULL);
                _exit(0);
        }
        else if (pid > 0)
                waitpid(pid, NULL, 0);
}
                                                                                                                                               

#endif
char *nvram_get_setting(char *name){
	uint i=0;
       	if (!name)
        	return NULL;

        /* Find the associated tuple in the hash table */
        for (i=0;i<MAX_T;i++)
        {
                if(strcmp(testConfig[i].var,name)==0)
                {
#if UPNP_DEBUG
                      //  //fprintf(stderr,"nvram_get:the name is %s:%s, the val is\n",testConfig[i].var,name,testConfig[i].val);
#endif
                        return testConfig[i].val;
                }
        }
	return NULL;

}
/* 
pikachu added for use iptables to add ith rule(op=1) or delete ith rule(op=-1) 

*/

void iptables_operate(int i,unsigned int op1)
{
	char *name = "forward_portXXXXXXXXXX",value[1000];
        char *wan_port0, *wan_port1, *lan_ipaddr, *lan_port0, *lan_port1, *proto;
        char *enable, *desc;
	char command[500];
	char wan_if[32];
	snprintf(name, sizeof(name), "forward_port%d", i);
        if(nvram_get(name)!=NULL)
        {
                strncpy(value, nvram_get(name), sizeof(value));
	}
	else
	{
		//fprintf(stderr,"nvram_del_not_find:%d\n",i);
		return; //dont operate,it finished
	}
        lan_ipaddr = value;
        wan_port0 = strsep(&lan_ipaddr, ">");
        if (!lan_ipaddr)
                return ;//FALSE;

        /* Check for LAN destination port specification */
        lan_port0 = lan_ipaddr;
        lan_ipaddr = strsep(&lan_port0, ":");
        if (!lan_port0)
                return ;//FALSE;
        /* Check for protocol specification */
        proto = lan_port0;
        lan_port0 = strsep(&proto, ":,");
        if (!proto)
                return ;//FALSE;

        /* Check for enable specification */
        enable = proto;
        proto = strsep(&enable, ":,");

        desc = enable;
        enable = strsep(&desc, ":,");

        /* Check for WAN destination port range (optional) */
        wan_port1 = wan_port0;
        wan_port0 = strsep(&wan_port1, "-");
        if (!wan_port1)
                wan_port1 = wan_port0;
        /* Check for LAN destination port range (optional) */
        lan_port1 = lan_port0;
        lan_port0 = strsep(&lan_port1, "-");
        if (!lan_port1)
                lan_port1 = lan_port0;

	strcpy(wan_if,(char*)nvram_get_setting("wan_ifname"));

#if UPNP_DEBUG
	//fprintf(stderr,"######operate################\n");

        //fprintf(stderr,"operate-data(op:%d):%s-%s>%s:%s-%s,%s,%s,%s\n",op1, wan_port0, wan_port1,lan_ipaddr , lan_port0, lan_port1, proto, enable, desc);
#endif
	if(!strncasecmp(enable,"on",2))
	{
  		if(op1==1)
		{
			sprintf(command, "iptables -t nat -A UPNP_PRT -i %s -p %s --dport %s -j DNAT --to %s:%s-%s",wan_if , proto, wan_port0, lan_ipaddr, lan_port0,lan_port1);
		//fprintf(stderr,"command:%s\n",command);
        		do_command/*system*/(command);
                        sprintf(command,"iptables -I UPNP_FWD -p %s -d %s --dport %s -j ACCEPT",  proto, lan_ipaddr,lan_port0);
		//fprintf(stderr,"command:%s\n",command);
                    do_command/*system*/(command);
                               //   sprintf(command,"iptables -D FORWARD -p %s -d %s --dport %s -j ACCEPT",  proto, lan_ipaddr,lan_port0);
                              //   system(command);

		//	sprintf(command, "iptables -t nat -D PREROUTING -p %s --dport %s -j DNAT --to %s:%s", proto, wan_port0, lan_ipaddr, lan_port0);
                    //             fprintf(stderr,"command:%s\n",command);
                  //               do_command/*system */(command);
		}
		else if(op1==-1)
		{
		
			sprintf(command, "iptables -t nat -D UPNP_PRT -i %s -p %s --dport %s -j DNAT --to %s:%s-%s",wan_if, proto, wan_port0, lan_ipaddr,lan_port0, lan_port1);
		
			//fprintf(stderr,"command:%s\n",command);
        		do_command/*system*/ (command);
			 sprintf(command, "iptables -t nat -D UPNP_PRT -p %s --dport %s -j DNAT --to %s:%s",proto, wan_port0, lan_ipaddr,lan_port0);
			//fprintf(stderr,"command:%s\n",command);
			do_command/*system */(command);
			sprintf(command,"iptables -D UPNP_FWD -p %s -d %s --dport %s -j ACCEPT",  proto, lan_ipaddr,lan_port0);
			 //fprintf(stderr,"command:%s\n",command);
	            do_command/*system*/(command);

		}
		else if(op1==0)
		{
		       sprintf(command, "iptables -t nat -A UPNP_PRT -i %s -p %s --dport %s -j DNAT --to %s:%s-%s",wan_if , proto, wan_port0, lan_ipaddr, lan_port0,lan_port1); 

                //fprintf(stderr,"command:%s\n",command);
                        do_command/*system*/ (command);
                        sprintf(command,"iptables -I UPNP_FWD -p %s -d %s --dport %s -j ACCEPT",  proto, lan_ipaddr,lan_port0);
            
                //fprintf(stderr,"command:%s\n",command);
		    do_command/*system*/(command);
		}	
	}
	else
	{
		if(op1==1)
		{
		sprintf(command, "iptables -t nat -D UPNP_PRT -i %s -p %s --dport %s -j DNAT --to %s:%s-%s",wan_if, proto, wan_port0, lan_ipaddr, lan_port0,lan_port1);
		
		//fprintf(stderr,"command:%s",command);

		do_command/*system*/(command);
		sprintf(command, "iptables -t nat -D UPNP_PRT -p %s --dport %s -j DNAT --to %s:%s", proto, wan_port0, lan_ipaddr, lan_port0);
		do_command/*system*/(command);
                //fprintf(stderr,"command:%s",command);

		sprintf(command,"iptables -D UPNP_FWD -p %s -d %s --dport %s -j ACCEPT", proto, lan_ipaddr, lan_port0);
            do_command/*system*/(command);
		 //fprintf(stderr,"command:%s",command);
		}
		else if((op1==-1)||(op1==0))
		{
			//fprintf(stderr,"off cant del iptables\n");
		}
	}

}


int osl_ifstats(char *ifname, if_stats_t *pstats )
{
    extern int get_dev_fields(char *, int , if_stats_t *);
    extern int procnetdev_version(char *);
    extern char *get_name(char *, char *);

    FILE *fh;
    char buf[512];
    int err;
    int procnetdev_vsn;  /* version information */

    memset(pstats, 0, sizeof(*pstats));
    
    fh = fopen(_PATH_PROCNET_DEV, "r");
    if (!fh) {
	//fprintf(stderr, "Warning: cannot open %s (%s). Limited output.\n",
		//_PATH_PROCNET_DEV, strerror(errno)); 
	return 0;
    }	

    fgets(buf, sizeof buf, fh);	/* eat line */
    fgets(buf, sizeof buf, fh);

    procnetdev_vsn = procnetdev_version(buf);
    
    err = 0;
    while (fgets(buf, sizeof buf, fh)) {
	char *s;
	char name[50];
	
	s = get_name(name, buf);
	if (strcmp(name, ifname) == 0) {
	    get_dev_fields(s, procnetdev_vsn, pstats);
	    break;
	}
    }
    if (ferror(fh)) {
	perror(_PATH_PROCNET_DEV);
	err = -1;
    }
    fclose(fh);

    return err;
}


void osl_igd_disable(char *ifname)
{
    /* release the lease on the external interface. */
    char sigusr2[] = "-XX";
    
    sprintf(sigusr2, "-%d", SIGUSR2);
    ////eval("killall", sigusr2, "udhcpc");Aki TBD
}


void osl_igd_enable(char *ifname)
{
    /* renew the lease on the external interface. */
    char sigusr1[] = "-XX";
    
    sprintf(sigusr1, "-%d", SIGUSR1);
   //// eval("killall", sigusr1, "udhcpc"); Aki TBD
}



/* Return OSL_LINK_UP if the link status given interface is UP, OSL_LINK_DOWN otherwise. */
osl_link_t osl_link_status(char *devname)
{
    struct ifreq ifr;
    int fd, err;
    uint if_up = OSL_LINK_DOWN;
    struct ethtool_cmd ecmd;

    if_up = OSL_LINK_UP;	// Our ethernet driver isn't support SIOCETHTOOL, so we must force to UP, by honor
    return if_up;

    /* Setup our control structures. */
    memset(&ifr, 0, sizeof(ifr));
    strcpy(ifr.ifr_name, devname);

    /* Open control socket. */
    fd = socket(AF_INET, SOCK_DGRAM, 0);
    if (fd >= 0) {
	ecmd.cmd = ETHTOOL_GSET;
	ifr.ifr_data = (caddr_t)&ecmd;
	err = ioctl(fd, SIOCETHTOOL, &ifr);
	if (err >= 0) {
	    switch (ecmd.speed) {
	    case SPEED_10:
	    case SPEED_100:
	    case SPEED_1000:
		if_up = OSL_LINK_UP;
		break;
	    };
	}

	/* close the control socket */
	close(fd);
    }

    return if_up;
}


uint osl_max_bitrates(char *devname, ulong *rx, ulong *tx)
{
    struct ethtool_cmd ecmd;
    struct ifreq ifr;
    int fd, err;
    long speed = 0;

    *rx = *tx = 100*1000000;	// Our ethernet driver isn't support SIOCETHTOOL, so we must force to 100Mb, by honor
    return TRUE;

    /* Setup our control structures. */
    memset(&ifr, 0, sizeof(ifr));
    strcpy(ifr.ifr_name, devname);

    /* Open control socket. */
    fd = socket(AF_INET, SOCK_DGRAM, 0);
    if (fd >= 0) {
	ecmd.cmd = ETHTOOL_GSET;
	ifr.ifr_data = (caddr_t)&ecmd;
	err = ioctl(fd, SIOCETHTOOL, &ifr);
	if (err >= 0) {
	    u_int32_t mask = ecmd.supported;

	    // dump_ecmd(&ecmd);

	    if ((mask & (ADVERTISED_1000baseT_Half|ADVERTISED_1000baseT_Full))) {
		speed = (1000 * 1000000);
   	    } else if ((mask & (ADVERTISED_100baseT_Half|ADVERTISED_100baseT_Full))) {
		speed = (100 * 1000000);
	    } else if ((mask & (ADVERTISED_10baseT_Half|ADVERTISED_10baseT_Full))) {
		speed = (10 * 1000000);
	    } else {
		speed = 0;
	    }
	} else {
	    //fprintf(stderr,"ioctl(SIOCETHTOOL) failed in %s\n", __FUNCTION__);
	}

	/* close the control socket */
	close(fd);
    } else {
	//fprintf(stderr,"cannot open socket in %s\n", __FUNCTION__);
    }

    *rx = *tx = speed;

    return TRUE;
}


/*
static void dump_supported(struct ethtool_cmd *ep)
{
	u_int32_t mask = ep->supported;
	int did1;

	//fprintf(stdout, "	Supported ports: [ ");
	if (mask & SUPPORTED_TP)
		fprintf(stdout, "TP ");
	if (mask & SUPPORTED_AUI)
		fprintf(stdout, "AUI ");
#ifdef notdef
	if (mask & SUPPORTED_BNC)
		fprintf(stdout, "BNC ");
#endif
	if (mask & SUPPORTED_MII)
		fprintf(stdout, "MII ");
	if (mask & SUPPORTED_FIBRE)
		fprintf(stdout, "FIBRE ");
	fprintf(stdout, "]\n");

	fprintf(stdout, "	Supported link modes:   ");
	did1 = 0;
	if (mask & SUPPORTED_10baseT_Half) {
		did1++; fprintf(stdout, "10baseT/Half ");
	}
	if (mask & SUPPORTED_10baseT_Full) {
		did1++; fprintf(stdout, "10baseT/Full ");
	}
	if (did1 && (mask & (SUPPORTED_100baseT_Half|SUPPORTED_100baseT_Full))) {
		fprintf(stdout, "\n");
		fprintf(stdout, "	                        ");
	}
	if (mask & SUPPORTED_100baseT_Half) {
		did1++; fprintf(stdout, "100baseT/Half ");
	}
	if (mask & SUPPORTED_100baseT_Full) {
		did1++; fprintf(stdout, "100baseT/Full ");
	}
	if (did1 && (mask & (SUPPORTED_1000baseT_Half|SUPPORTED_1000baseT_Full))) {
		fprintf(stdout, "\n");
		fprintf(stdout, "	                        ");
	}
	if (mask & SUPPORTED_1000baseT_Half) {
		did1++; fprintf(stdout, "1000baseT/Half ");
	}
	if (mask & SUPPORTED_1000baseT_Full) {
		did1++; fprintf(stdout, "1000baseT/Full ");
	}
	fprintf(stdout, "\n");

	fprintf(stdout, "	Supports auto-negotiation: ");
	if (mask & SUPPORTED_Autoneg)
		fprintf(stdout, "Yes\n");
	else
		fprintf(stdout, "No\n");
}
static void dump_advertised(struct ethtool_cmd *ep)
{
	u_int32_t mask = ep->advertising;
	int did1;

	fprintf(stdout, "	Advertised link modes:  ");
	did1 = 0;
	if (mask & ADVERTISED_10baseT_Half) {
		did1++; fprintf(stdout, "10baseT/Half ");
	}
	if (mask & ADVERTISED_10baseT_Full) {
		did1++; fprintf(stdout, "10baseT/Full ");
	}
	if (did1 && (mask & (ADVERTISED_100baseT_Half|ADVERTISED_100baseT_Full))) {
		fprintf(stdout, "\n");
		fprintf(stdout, "	                        ");
	}
	if (mask & ADVERTISED_100baseT_Half) {
		did1++; fprintf(stdout, "100baseT/Half ");
	}
	if (mask & ADVERTISED_100baseT_Full) {
		did1++; fprintf(stdout, "100baseT/Full ");
	}
	if (did1 && (mask & (ADVERTISED_1000baseT_Half|ADVERTISED_1000baseT_Full))) {
		fprintf(stdout, "\n");
		fprintf(stdout, "	                        ");
	}
	if (mask & ADVERTISED_1000baseT_Half) {
		did1++; fprintf(stdout, "1000baseT/Half ");
	}
	if (mask & ADVERTISED_1000baseT_Full) {
		did1++; fprintf(stdout, "1000baseT/Full ");
	}
	if (did1 == 0)
		 fprintf(stdout, "Not reported");
	fprintf(stdout, "\n");

	fprintf(stdout, "	Advertised auto-negotiation: ");
	if (mask & ADVERTISED_Autoneg)
		fprintf(stdout, "Yes\n");
	else
		fprintf(stdout, "No\n");
}

static int dump_ecmd(struct ethtool_cmd *ep)
{
	dump_supported(ep);
	dump_advertised(ep);

	fprintf(stdout, "	Speed: ");
	switch (ep->speed) {
	case SPEED_10:
		fprintf(stdout, "10Mb/s\n");
		break;
	case SPEED_100:
		fprintf(stdout, "100Mb/s\n");
		break;
	case SPEED_1000:
		fprintf(stdout, "1000Mb/s\n");
		break;
	default:
		fprintf(stdout, "Unknown! (%i)\n", ep->speed);
		break;
	};

	fprintf(stdout, "	Duplex: ");
	switch (ep->duplex) {
	case DUPLEX_HALF:
		fprintf(stdout, "Half\n");
		break;
	case DUPLEX_FULL:
		fprintf(stdout, "Full\n");
		break;
	default:
		fprintf(stdout, "Unknown! (%i)\n", ep->duplex);
		break;
	};

	fprintf(stdout, "	Port: ");
	switch (ep->port) {
	case PORT_TP:
		fprintf(stdout, "Twisted Pair\n");
		break;
	case PORT_AUI:
		fprintf(stdout, "AUI\n");
		break;
	case PORT_BNC:
		fprintf(stdout, "BNC\n");
		break;
	case PORT_MII:
		fprintf(stdout, "MII\n");
		break;
	case PORT_FIBRE:
		fprintf(stdout, "FIBRE\n");
		break;
	default:
		fprintf(stdout, "Unknown! (%i)\n", ep->port);
		break;
	};

	fprintf(stdout, "	PHYAD: %d\n", ep->phy_address);
	fprintf(stdout, "	Transceiver: ");
	switch (ep->transceiver) {
	case XCVR_INTERNAL:
		fprintf(stdout, "internal\n");
		break;
	case XCVR_EXTERNAL:
		fprintf(stdout, "externel\n");
		break;
	default:
		fprintf(stdout, "Unknown!\n");
		break;
	};

	fprintf(stdout, "	Auto-negotiation: %s\n",
		(ep->autoneg == AUTONEG_DISABLE) ?
		"off" : "on");
	return 0;
}

*/
void osl_sys_restart()
{
    kill(1, SIGHUP);
}

void osl_sys_reboot()
{
    kill(1, SIGTERM);
}

bool osl_wan_isup(char *devname)
{
    struct in_addr inaddr = {0};
    bool status = FALSE;
	char tmp[100];

    if (strcasecmp(nvram_safe_get(igd_pri_wan_var(tmp, sizeof(tmp), "proto")), "disabled") != 0) {
    //fprintf(stderr,"osl_wan_isup:get ifname\n");
	if (osl_ifaddr(nvram_safe_get(igd_pri_wan_var(tmp, sizeof(tmp), "ifname")), &inaddr)) {
	    if (inaddr.s_addr != 0) {
		status = TRUE;
	    }
	} 
    }
    return status;
}

bool osl_lan_isup(char *devname)
{
    //fprintf(stderr,"%s is not implemented yet.\n", __FUNCTION__);
    return TRUE;
}

bool osl_set_macaddr(char *devname, char spoofed[]) 
{
    //fprintf(stderr,"%s is not implemented yet.\n", __FUNCTION__);
    return TRUE;
}
 
#if 0

void upnp_table_show()
{
	int i=0;
	upnptableS *ptr;
	ptr=upnp_table;
	//fprintf(stderr,"===============================================\n");
	while(ptr!=NULL)
	{
		fprintf(stderr,"table[%d]={%s,%s}\n",i,ptr->var,ptr->val);
		i++;
		ptr=ptr->next;
	}
}
#endif

void upnp_setting_init()
{
	int i=1;
        FILE *fp;
        char tempvar[25],tempval[500];
        //char *temp,*ptr;
        fp=fopen(UPNP_SETTING_FILE,"r");
//	fprintf(stderr,"UPNP_SETTING_INIT....\n");
        if(!fp) {
                return ;
        }
        //   1     2
        // |var|value|
        while((fscanf(fp,"|%25[^|]|%50[^|]|\n",tempvar,tempval))!=-1)
        {
		if(strcmp(tempvar,"End of File")==0)
		{
			break;
		}
		strcpy(testConfig[i].var,tempvar);
		//fprintf(stderr,"tempvar:%s\n",tempvar);
		strcpy(testConfig[i].val,tempval);
		//fprintf(stderr,"tempval:%s\n",tempval);
		fprintf(stderr,"testConfig[%d]={%s,%s}\n",i,testConfig[i].var,testConfig[i].val);
		i++;
	}
	fclose(fp);
//	fprintf(stderr,"UPNP_SETTING_INIT...END.\n");
	
}

void
upnp_table_init()
{
        int j=0;
	FILE *fp;
	char tempvar[25],tempval[500];
	upnptableS *temp,*ptr;
        fp=fopen(UPNP_TABLE_FILE,"r");

        if(!fp) {
                return ;
        }
        //   1     2      
        // |var|value|
                while((fscanf(fp,"|%20[^|]|%500[^|]|\n",tempvar,tempval))!=-1)
		{
			if(strcmp(tempvar,"?ipnp_ex")==0)
			{
				fclose(fp);
				return;
			}	
   	                //temp=(struct upnptableS*)malloc(sizeof(*temp));
   	                temp=(upnptableS *)malloc(sizeof(*temp));
                        strcpy(temp->var,tempvar);
                        strcpy(temp->val,tempval);
                        temp->next=NULL;
			
			ptr=upnp_table;
		        if(ptr==NULL)
                		upnp_table=temp;
        		else
        		{
                		temp->next=upnp_table;
                		upnp_table=temp;
        		}
        	}

        fclose(fp);
#if UPNP_DEBUG
        upnp_table_show();
#endif
        ptr=upnp_table;
        while(ptr!=NULL)
        {
                iptables_operate(j,0);
                j++;
                ptr=ptr->next;
        }
}












 /* Get the value of an NVRAM variable. Should be locked. */

char *
nvram_get(const char *name)
{
	uint i=0;
	upnptableS *ptr;
	ptr=upnp_table;
	if (!name)
		return NULL;
        for (i=0;i<MAX_T;i++)
        {
                if(strcmp(testConfig[i].var,name)==0)
                {
#if UPNP_DEBUG
                       // fprintf(stderr,"nvram_get:the name is %s:%s, the val is\n",testConfig[i].var,name,testConfig[i].val);

#endif
                        return testConfig[i].val;
                }
        }


	while(ptr!=NULL)
	{
		if(strcmp(ptr->var,name)==0)
		{
			return ptr->val;
		}
		ptr=ptr->next;
	}
	return NULL;
}

/* Delete the value of an NVRAM variable. Should be locked. */
int
nvram_del(const char *name)
{
       uint j;
       //int update=0;
	char mark[] = "?upnp";
	char item[]="\0";
	int item_num=0;
       upnptableS *ptr,*temp;
       ptr=upnp_table;
	temp=ptr;
       while(ptr!=NULL)
       {

                //fprintf(stderr,"nvram_del 2nd name:%s\n",name);

                if(strcmp(ptr->var,name)==0)
		{
			
			strcpy(ptr->var,mark);
			
			ptr=ptr->next;
		}
	if(ptr!=NULL){	
		if(strcmp(ptr->var,name)>0)
                {
                      //change forward_portXXXX 
		//	item_num=strcmp(ptr->var,item);
			for(j=0;j+12<strlen(ptr->var);j++)
                		item[j]=ptr->var[12+j];
        		item_num=atoi(item);
			sprintf(item,"forward_port%d",item_num-1);
			strcpy(ptr->var,item);
			//fprintf(stderr,"var:%s,item:%s\n",ptr->var,item);
			
                }
		ptr=ptr->next;
	}
	}
#if UPNP_DEBUG
	upnp_table_show();
#endif
	ptr=upnp_table;		
	if(strcmp(ptr->var,mark)==0)
	{
		upnp_table=ptr->next;
		free(ptr);
        	//upnp_table_show();
		return 0;
	}	
       while(ptr!=NULL)
       {
		
                //fprintf(stderr,"nvram_del 2nd name:%s\n",mark);
                if(strcmp(ptr->var,mark)==0)
                {
                 	temp->next=ptr->next;
			free(ptr);
        		//upnp_table_show();
		        return 0;
                }
		temp=ptr;
                ptr=ptr->next;
        }
        return 0;


}
 


/* Set the value of an NVRAM variable. Should be locked. */
int
nvram_set(const char *name, const char *value)
{
       uint i;
       int update=0;
       upnptableS *ptr,*temp;
       ptr=upnp_table;
	for (i=0;i<MAX_T;i++)
        {
                if(strcmp(testConfig[i].var,name)==0)
                {
			strcpy(testConfig[i].val,value);
			update=1;
                        //return testConfig[i].val;
                }
        }
	if(update==0)
	{
	        while(ptr!=NULL)
	        {
        	        //fprintf(stderr,"nvram_set name:%s\n",name);
			if(strcmp(ptr->var,name)==0)
                	{
#if UPNP_DEBUG
                        	fprintf(stderr,"###############################\n");
                        	fprintf(stderr,"change->%s,%s\n",ptr->var,ptr->val);
#endif
                        	strcpy(ptr->val,value);
				update=1;
#if UPNP_DEBUG
				fprintf(stderr,"to->%s\n",ptr->val);
#endif
				return 0;
                	}
                	ptr=ptr->next;
        	}
	}
	if(update==0)//not in table,now insert
	{
		
       		temp=(upnptableS*)malloc(sizeof(*temp));
		//fprintf(stderr,"now insert in upnp table(%s,%s)\n",name,value);
		strcpy(temp->var,name);
		//strcpy(temp->val,value);
		strcpy(temp->val,"newvalue");
		ptr=upnp_table;
		temp->next=ptr;
		upnp_table=temp;
		
	}
#if UPNP_DEBUG
	upnp_table_show();
#endif	
	return 0;
}


/* Regenerate NVRAM. Should be locked. */
int
nvram_commit(void)
{



	return 0;
}
#include "netconf.h"

bool
valid_forward_port(const netconf_nat_t *nat)
{
        //fprintf(stderr,"pikachu-check valid_forward_port\n");
	/* Check WAN destination port range */
        if (ntohs(nat->match.dst.ports[0]) > ntohs(nat->match.dst.ports[1]))
	{
	//fprintf(stderr,"pikachu-check valid_forward_port:1\n");
                return FALSE;
	}
        /* Check protocol */
        if (nat->match.ipproto != IPPROTO_TCP && nat->match.ipproto != IPPROTO_UDP)
       {
        //fprintf(stderr,"pikachu-check valid_forward_port:1\n");
                return FALSE;
        }

        /* Check LAN IP address */
        if (nat->ipaddr.s_addr == htonl(0))
       {
        //fprintf(stderr,"pikachu-check valid_forward_port:2\n");
                return FALSE;
        }

        /* Check LAN destination port range */
        if (ntohs(nat->ports[0]) > ntohs(nat->ports[1]))
       {
        //fprintf(stderr,"pikachu-check valid_forward_port:3\n");
                return FALSE;
        }

        /* Check port range size */
        if ((ntohs(nat->match.dst.ports[1]) - ntohs(nat->match.dst.ports[0])) !=
            (ntohs(nat->ports[1]) - ntohs(nat->ports[0])))
       {
        //fprintf(stderr,"pikachu-check valid_forward_port:4\n");
                return FALSE;
        }
#if UPNP_DEBUG
	fprintf(stderr,"pikachu-valid_forward_port TRUE\n");
#endif
        return TRUE;
}
/* for init forward_mapping by pikachu */
bool
get_forward_port_init(int which, netconf_nat_t *nat)
{
        char name[] = "forward_portXXXXXXXXXX";
//	char value[1000];
        char *wan_port0=NULL, *wan_port1=NULL, *lan_ipaddr=NULL, *lan_port0=NULL, *lan_port1=NULL, *proto=NULL;
        char *enable=NULL, *desc=NULL;
        char *tempval=NULL;
	int tempval_len=0,i=0;

        memset(nat, 0, sizeof(netconf_nat_t));
	fprintf(stderr,"pikachu(linux-igd.c):get_forward_port\n");
        /* Parse wan_port0-wan_port1>lan_ipaddr:lan_port0-lan_port1[:,]proto[:,]enable[:,]desc */
        snprintf(name, sizeof(name), "forward_port%d", which);
        if(!nvram_get(name))
	{
		strcpy(tempval,nvram_get(name));
		tempval_len=strlen(tempval);
	}
	else
		return FALSE;
//        fprintf(stderr,"val(%d):%s\n",tempval_len,tempval);	
	for(i=0;i<tempval_len;i++)
	{
		if(tempval[i]=='-')
			break;
	}
	//strncpy(wan_port1,tempval[0],sizeof(i));
	strncpy(wan_port1,tempval,sizeof(i));

                wan_port1 = wan_port0;
        /* Check for LAN destination port range (optional) */
        lan_port1 = lan_port0;

        /* Parse WAN destination port range */
        nat->match.dst.ports[0] = htons(atoi(wan_port0));
        nat->match.dst.ports[1] = htons(atoi(wan_port1));

                (void) inet_aton(lan_ipaddr, &nat->ipaddr);
        nat->ports[0] = htons(atoi(lan_port0));
        nat->ports[1] = htons(atoi(lan_port1));

        /* Parse protocol */
        if (!strncasecmp(proto, "tcp", 3))
                nat->match.ipproto = IPPROTO_TCP;
        else if (!strncasecmp(proto, "udp", 3))
                nat->match.ipproto = IPPROTO_UDP;
        else
                return FALSE;

        /* Parse enable */
        if (!strncasecmp(enable, "off", 3))
                nat->match.flags = NETCONF_DISABLED;

        /* Parse description */
        if (desc)
                strncpy(nat->desc, desc, sizeof(nat->desc));
        /* Set WAN source port range (match packets from any source port) */
        nat->match.src.ports[1] = htons(0xffff);


        /* Set target (DNAT) */
        nat->target = NETCONF_DNAT;

        //fprintf(stderr,"%s-%s>%s:%s-%s,%s,%s,%s", wan_port0, wan_port1,"lanip" , lan_port0, lan_port1, proto, enable, desc);
        return valid_forward_port(nat);
}	

bool
get_forward_port(int which, netconf_nat_t *nat)
{
        char name[] = "forward_portXXXXXXXXXX", value[1000];
        char *wan_port0, *wan_port1, *lan_ipaddr, *lan_port0, *lan_port1, *proto;
        char *enable, *desc;

        memset(nat, 0, sizeof(netconf_nat_t));
        /* Parse wan_port0-wan_port1>lan_ipaddr:lan_port0-lan_port1[:,]proto[:,]enable[:,]desc */
        snprintf(name, sizeof(name), "forward_port%d", which);
	if(nvram_get(name)!=NULL)
        {
		strncpy(value, nvram_get(name), sizeof(value));
        }
        else
                return FALSE;

        /* Check for LAN IP address specification */
        lan_ipaddr = value;
        wan_port0 = strsep(&lan_ipaddr, ">");
        if (!lan_ipaddr)
                return FALSE;

        /* Check for LAN destination port specification */
        lan_port0 = lan_ipaddr;
        lan_ipaddr = strsep(&lan_port0, ":");
        if (!lan_port0)
                return FALSE;
        /* Check for protocol specification */
        proto = lan_port0;
        lan_port0 = strsep(&proto, ":,");
        if (!proto)
                return FALSE;

        /* Check for enable specification */
        enable = proto;
        proto = strsep(&enable, ":,");

        if (!enable)
                return FALSE;

        /* Check for description specification (optional) */
        desc = enable;
        enable = strsep(&desc, ":,");

        /* Check for WAN destination port range (optional) */
        wan_port1 = wan_port0;
        wan_port0 = strsep(&wan_port1, "-");
        if (!wan_port1)
                wan_port1 = wan_port0;
        /* Check for LAN destination port range (optional) */
        lan_port1 = lan_port0;
        lan_port0 = strsep(&lan_port1, "-");
        if (!lan_port1)
                lan_port1 = lan_port0;

        /* Parse WAN destination port range */
        nat->match.dst.ports[0] = htons(atoi(wan_port0));
        nat->match.dst.ports[1] = htons(atoi(wan_port1));

        /* Parse LAN IP address */
        /* Check IP, add by honor temp del pikachu*/
//        if(get_single_ip(lan_ipaddr, 0) != get_single_ip(nvram_safe_get("lan_ipaddr"), 0) ||
//           get_single_ip(lan_ipaddr, 1) != get_single_ip(nvram_safe_get("lan_ipaddr"), 1) ||
//           get_single_ip(lan_ipaddr, 2) != get_single_ip(nvram_safe_get("lan_ipaddr"), 2)){
                /* Lan IP Address have been changed, so we must to adjust IP */
//                char ip3[5];
//                char *ip;
//                char buf[254];
//                snprintf(ip3, sizeof(ip3), "%d", get_single_ip(lan_ipaddr, 3));
//                ip = get_complete_lan_ip(ip3);
//                (void) inet_aton(ip, &nat->ipaddr);
//                snprintf(buf, sizeof(buf), "%s-%s>%s:%s-%s,%s,%s,%s", wan_port0, wan_port1, ip, lan_port0, lan_port1, proto, enable, desc);
//                nvram_set(name, buf);
//        }
//        else
                (void) inet_aton(lan_ipaddr, &nat->ipaddr);
        
	/* Parse LAN destination port range */
        nat->ports[0] = htons(atoi(lan_port0));
        nat->ports[1] = htons(atoi(lan_port1));

        /* Parse protocol */
        if (!strncasecmp(proto, "tcp", 3))
                nat->match.ipproto = IPPROTO_TCP;
        else if (!strncasecmp(proto, "udp", 3))
                nat->match.ipproto = IPPROTO_UDP;
        else
                return FALSE;

        /* Parse enable */
        if (!strncasecmp(enable, "off", 3))
                nat->match.flags = NETCONF_DISABLED;

        /* Parse description */
        if (desc)
                strncpy(nat->desc, desc, sizeof(nat->desc));
        /* Set WAN source port range (match packets from any source port) */
        nat->match.src.ports[1] = htons(0xffff);


        /* Set target (DNAT) */
        nat->target = NETCONF_DNAT;
#if UPNP_DEBUG
        //fprintf(stderr,"inputdata:%s-%s>%s:%s-%s,%s,%s,%s", wan_port0, wan_port1,lan_ipaddr , lan_port0, lan_port1, proto, enable, desc);
#endif
        return valid_forward_port(nat);


}	

bool
set_forward_port(int which, const netconf_nat_t *nat)
{
        char name[] = "forward_portXXXXXXXXXX", value[1000], *cur = value;
        int len,op;

        if (!valid_forward_port(nat))
                return FALSE;
	

	fprintf(stderr,"pikachu(linux-igd.c):set_forward_port%d\n",which);
        /* Set wan_port0-wan_port1>lan_ipaddr:lan_port0-lan_port1,proto,enable,desc */
        snprintf(name, sizeof(name), "forward_port%d", which);
        if(nvram_get(name)!=NULL)
        {
                strncpy(value, nvram_get(name), sizeof(value));
        }
        else
	{
		fprintf(stderr,"Cant find Data!!!\n");
		//snprintf(value, nvram_get("?upnp_ex"), sizeof(value));
		strncpy(value, nvram_get("?upnp_ex"), sizeof(value));
	        if (nvram_set(name, value))
		{
        		fprintf(stderr,"nvram_set_return_FALSE\n"); 
		       //return FALSE;
		}
	}
        len = sizeof(value);
	*cur = value[0];
        /* Set WAN destination port range */
       cur = safe_snprintf(cur, &len, "%d", ntohs(nat->match.dst.ports[0]));
        //cur = safe_snprintf(cur, &len, "%d", ntohs(nat->match.dst.ports[0]));
        cur = safe_snprintf(cur, &len, "-");
        cur = safe_snprintf(cur, &len, "%d", ntohs(nat->match.dst.ports[1]));

        /* Set LAN IP address */
        cur = safe_snprintf(cur, &len, ">");
        cur = safe_snprintf(cur, &len, inet_ntoa(nat->ipaddr));

        /* Set LAN destination port range */
        cur = safe_snprintf(cur, &len, ":");
        cur = safe_snprintf(cur, &len, "%d", ntohs(nat->ports[0]));
        cur = safe_snprintf(cur, &len, "-");
        cur = safe_snprintf(cur, &len, "%d", ntohs(nat->ports[1]));

        /* Set protocol */
        cur = safe_snprintf(cur, &len, ",");
        if (nat->match.ipproto == IPPROTO_TCP)
                cur = safe_snprintf(cur, &len, "tcp");
        else if (nat->match.ipproto == IPPROTO_UDP)
                cur = safe_snprintf(cur, &len, "udp");

        /* Set enable */
        cur = safe_snprintf(cur, &len, ",");
        if (nat->match.flags & NETCONF_DISABLED)
	{
                cur = safe_snprintf(cur, &len, "off");
		op=-1;
        }
	else
	{
                cur = safe_snprintf(cur, &len, "on");
		op=1;
	}
        /* Set description */
        if (*nat->desc) {
                cur = safe_snprintf(cur, &len, ",");
                cur = safe_snprintf(cur, &len, nat->desc);
        }
	
        /* Do it pikachu temp del*/
        if (!nvram_set(name, value))
	{               // return FALSE;
	   fprintf(stderr,"cur:%d\n",op);	 
	    iptables_operate(which,op);
	}
        return TRUE;

}

bool
del_forward_port(int which)
{
        char name[] = "forward_portXXXXXXXXXX";
	
        snprintf(name, sizeof(name), "forward_port%d", which);
	fprintf(stderr,"del_forward_port:%d\n",which);
        if(nvram_get(name)!=NULL)
        {
		iptables_operate(which,-1);//-1  ->del iptable rule
		nvram_del(name);
		return TRUE;
        }
        else
                return FALSE;
}
