#!/bin/sh
# Make image:
#	*usage: chmag.sh inputfilename
# 	*input: (8K+112K=120K bootrom)/ (gziped kenerl+ap images)
# 	*output: header-changed gzipped image
# Make gzipped image and get KERNEL_START_ADDRESS:
#   *usage: chmag.sh -k inputfilename
#	*input: linux
#	*output: KERNEL_START_ADDRESS and gzipped linux image

######################################################
DATE=`date +%s | cut -c 1-9`
DATE1=`date +%M`
DATE2=`date +%N`


######################################################
######################################################
# Make gzipped image and get KERNEL_START_ADDRESS    #
######################################################
######################################################
if [ "$1" = "-k" ]; then
export OBJCOPY=/usr/local/mips-kgcc/bin/mips-linux-objcopy
export OBJDUMP=/usr/local/mips-kgcc/bin/mips-linux-objdump
$OBJCOPY -O binary $2 $2.bin
$OBJDUMP -x $2 | grep "start address" | awk '{ print $3 }' > tmpaddr ; 
#gzip -f -9 $2.bin
gzip -f -9 < $2.bin > $2.bin.gz; \
LC_ALL=C wc $2.bin.gz | awk '{ print $3 }' >> tmpaddr
echo "make gzipped image and KSA done"
echo ""
else

######################################################
######################################################
# change gzip header                                 #
######################################################
######################################################

echo "start change gzip header"
OUTPUT=$DATE2
mv $1 $DATE2
gzip -f -9 $OUTPUT
#
#gzip-3|123456789|gzip-4|12|gzip-5...
#
#
dd if=$OUTPUT.gz of=$OUTPUT.cgz bs=1 skip=2 count=1 && echo -n $DATE >> $OUTPUT.cgz
dd if=$OUTPUT.gz of=$OUTPUT.tmp1 bs=1 skip=3 count=1 && cat $OUTPUT.tmp1 >> $OUTPUT.cgz
echo -n $DATE1 >> $OUTPUT.cgz
dd if=$OUTPUT.gz of=$OUTPUT.tmp1 bs=1 skip=4 && cat $OUTPUT.tmp1 >> $OUTPUT.cgz
mv $OUTPUT.cgz $1.cgz
#clear tmp files
rm -f *.tmp1 *.bin *.gz 
echo "change gzip header done"
echo ""

fi
